CREATE TABLE IF NOT EXISTS Hash(
    id INTEGER,
    hash TEXT UNIQUE, /* snix-castore node */
    n_bytes INTEGER,
    PRIMARY KEY(id)
); /* Essentially random strings */
CREATE TABLE IF NOT EXISTS Str(
    id INTEGER,
    str TEXT UNIQUE,
    PRIMARY KEY(id)
); /* "Naturally occuring" strings */
CREATE INDEX IF NOT EXISTS StrIdx ON Str(str);
CREATE TABLE IF NOT EXISTS SidxUriSample(
    id INTEGER,
    uri INTEGER NOT NULL,
    hash INTEGER,
    epoch INTEGER NOT NULL DEFAULT (unixepoch()),
    http_code INTEGER DEFAULT NULL,
    PRIMARY KEY(id),
    FOREIGN KEY(uri) REFERENCES Str(id),
    FOREIGN KEY(hash) REFERENCES Hash(id)
);
CREATE INDEX IF NOT EXISTS SidxUriHashIdx
ON SidxUriSample(uri, epoch);

CREATE TABLE IF NOT EXISTS UriReference(
    content INTEGER,
    target INTEGER,
    why INTEGER,
    PRIMARY KEY (content, target, why),
    FOREIGN KEY(content) REFERENCES Hash(id),
    FOREIGN KEY(target) REFERENCES Str(id), /* E.g. Uri or Path */
    FOREIGN KEY(why) REFERENCES Str(id) /* E.g. "href" */
);
CREATE INDEX IF NOT EXISTS UriReferenceIdx
ON UriReference(target, content);
